/*
Kangaroo is Copyright (C) 2001 Douglas Thain.
Permission is granted to use the source code for research and study purposes.
Other uses must be cleared with the copyright holder.
*/


#include "auth.h"
#include "debug.h"
#include "network.h"

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include <unistd.h>
#include <errno.h>

static int auth_trivial_assert( FILE *r, FILE *w )
{
	char line[AUTH_LINE_MAX];
	int response=0;

	debug("auth_trivial: waiting for response\n");

	if(fgets(line,AUTH_LINE_MAX,r)) {
		sscanf(line,"%d",&response);
	}

	debug("auth_trivial: response is %d\n",response);

	return response;
}

static int auth_trivial_accept( FILE *r, FILE *w, char **subject )
{
	network_address addr;
	char host[NETWORK_NAME_MAX];
	int port;
	int result;

	*subject = 0;

	if(
		network_address_remote(fileno(r),&addr,&port) &&
		network_address_to_name(addr,host) &&
		(*subject = strdup(host))
	) {
		debug("auth_trivial: remote subject is %s\n",host);
		result = 1;
	} else {
		debug("auth_trivial: could not determine remote host: %s\n",strerror(errno));
		result = 0;
	}

	fprintf(w,"%d\n",result);
	fflush(w);
	return result;
}

int auth_trivial_register()
{
	return auth_register( "trivial", auth_trivial_assert, auth_trivial_accept );
}

