/*
Kangaroo is Copyright (C) 2001 Douglas Thain.
Permission is granted to use the source code for research and study purposes.
Other uses must be cleared with the copyright holder.
*/


#include <stdlib.h>
#include <stdarg.h>
#include <stdio.h>
#include <unistd.h>
#include <pthread.h>

static int debug_mode = 0;
static FILE *debug_stream = 0;

static pthread_mutex_t mutex = PTHREAD_MUTEX_INITIALIZER;

void debug( char *fmt, ... )
{
	va_list args;
	va_start(args,fmt);

	if(debug_mode) {
		if(!debug_stream) debug_stream = stderr;
		pthread_mutex_lock(&mutex);
		//fprintf(debug_stream,"%ld ",pthread_self());
		fprintf(debug_stream,"%ld ",getpid());
		vfprintf(debug_stream,fmt,args);
		fflush(debug_stream);
		pthread_mutex_unlock(&mutex);
	}

	va_end(args);
}

void debug_mode_set( int onoff )
{
	debug_mode = onoff;
}

void debug_stream_set( FILE *stream )
{
	debug_stream = stream;
}

int debug_mode_get()
{
	return debug_mode;
}

void debug_wait(void)	{
	
	if (getenv ("DEBUG_WAIT"))	{
		int i = 1;
		while (i)	
			;
	}
		
}
