#include "dep_graph.h"
#include "kangaroo_message.h"
#include "debug.h"
#include "list.h"
#include <stdlib.h>

int disp_messages(struct dep_graph_node *dgn,void *arg)
{
  struct kangaroo_message *m=dgn->m;
  printf("%d %s %s Off %d Len %d\n",m->type,m->addr,m->path,m->offset,m->length);
  return 1;
}


int main()
{
  int ch=1,gp;
  char addr[100],path[100];
  struct dep_graph * dg[10],*tdg;
  struct list *dgn_list;
  struct kangaroo_message *m;
  enum kangaroo_message_type type;
  debug_mode_set(1);
  dep_graph_table_create();
  do{
    printf("1. Add message\n2. what_next\n3. what to push\n4. pushed\n5. parallel_ops\n6. Rollback\n7. All Messages\n");
    printf("Enter your choice \n");
    scanf("%d",&ch);
    switch(ch){
    case 1:
      printf("Graph \n");
      scanf("%d",&gp);
      m=(struct kangaroo_message *)malloc(sizeof(struct kangaroo_message));
      printf("Address \n");
      scanf("%s",m->addr);
      printf("Path \n");
      scanf("%s",m->path);
      printf("Type \n");
      scanf("%d",&m->type);
      if(m->type==KANGAROO_PUT) {
	printf("Offset \n");
	scanf("%d",&m->offset);
	printf("len \n");
	scanf("%d",&m->length);
      }
      else
	if(m->type==KANGAROO_RENAME) {
	  printf("New name \n");
	  scanf("%s",m->newpath);
	}
      m->data=0;
      dg[gp]=dep_graph_insert_message(m);
      break;
    case 2:
      printf("Graph \n");
      scanf("%d",&gp);
      m=dep_graph_get_next(dg[gp],0);
      if(!m) break;
      printf("%d %s %s Off %d Len %d\n",m->type,m->addr,m->path,m->offset,m->length);
      break;
    case 3:
      printf("Graph \n");
      scanf("%d",&gp);
      dgn_list=dep_graph_what_to_push(dg[gp],0);
      if(!dgn_list) break;
      list_iterate(dgn_list,disp_messages,0);
      break;
    case 4:
      printf("Graph \n");
      scanf("%d",&gp);
      
      tdg=dep_graph_pushed(dg[gp],0);
      if(tdg!=dg[gp]) {
      printf("New Graph \n");
      scanf("%d",&gp);
      }
      dg[gp]=tdg;
      break;
    case 5:
      printf("Graph \n");
      scanf("%d",&gp);
      if(!dg[gp]) break;
      list_iterate(dg[gp]->parallel_ops,disp_messages,0);
      break;
    case 6:
      printf("Graph \n");
      scanf("%d",&gp);
      if(!dg[gp]) break;
      dep_graph_rollback(dg[gp],0);
      break;
    case 7:
      printf("Graph \n");
      scanf("%d",&gp);
      if(!dg[gp]) break;
      list_iterate(dg[gp]->node_list,disp_messages,0);
      break;
      
    }
  }while(ch!=0);
  return 0;
}




