
#include "disk_info.h"

#if defined(HAS_STATFS)
	#include <sys/types.h>
	#include <sys/statfs.h>
#elif defined(HAS_STATVFS)
	#include <sys/types.h>
	#include <sys/statvfs.h>
#else
#error You must have either statfs or statvfs!
#endif

int disk_info_get( const char *path, UINT64_T *avail, UINT64_T *total )
{
	int result;

#ifdef HAS_STATFS
	struct statfs s;
	result = statfs(path,&s);
#else
	struct statvfs s;
	result = statvfs(path,&s);
#endif

	if(result<0) return result;

	*total = ((UINT64_T)s.f_bsize)*s.f_blocks;
	*avail = ((UINT64_T)s.f_bsize)*s.f_bavail;

	return 0;
}
