/*
Kangaroo is Copyright (C) 2001 Douglas Thain.
Permission is granted to use the source code for research and study purposes.
Other uses must be cleared with the copyright holder.
*/

#include "list.h"
#include "hash_table.h"

static int transfer( struct hash_table *table, char *key, void *value, void *arg )
{
	struct list *l = (struct list *)arg;
	if(!list_push_tail(l,value)) return 0;
	return 1;
}

static int cleanup( struct hash_table *table, char *key, void *value, void *arg )
{
	hash_table_remove(table,key);
	return 1;
}

struct list * hash_table_to_list( struct hash_table *table )
{
	struct list *l;

	l = list_create();
	if(!l) return 0;

	if(hash_table_iterate(table,transfer,l)) {
		hash_table_iterate(table,cleanup,0);
		return l;
	} else {
		list_delete(l);
		return 0;
	}

}

