/*
Kangaroo is Copyright (C) 2001 Douglas Thain.
Permission is granted to use the source code for research and study purposes.
Other uses must be cleared with the copyright holder.
*/


#ifndef KANGAROO_SUMMARY_H
#define KANGAROO_SUMMARY_H

#include "kangaroo_types.h"
#include "message_list.h"
#include "list.h"

struct kangaroo_summary {
	char host[KANGAROO_HOST_MAX];
	char path[KANGAROO_PATH_MAX];
	long ops;
	long bytes;
};

enum kangaroo_summary_type {
	KANGAROO_SUMMARY_BY_HOST,
	KANGAROO_SUMMARY_BY_FILE,
};

struct list * kangaroo_summary_create( struct message_list *m, enum kangaroo_summary_type type );
int kangaroo_summary_total( struct message_list *m, long long *kb_used );

#endif
