/*
Kangaroo is Copyright (C) 2001 Douglas Thain.
Permission is granted to use the source code for research and study purposes.
Other uses must be cleared with the copyright holder.
*/


#ifndef LIST_H
#define LIST_H

typedef int (*list_op_t) ( void *item, const void *arg );

struct list * list_create();
struct list * list_splice( struct list *top, struct list *bottom );
void          list_delete( struct list *l );
int	      list_size( struct list *l );

int	      list_push_head( struct list *l, void *item );
void *	      list_pop_head( struct list *l );
void *	      list_peek_head( struct list *l );

int	      list_push_tail( struct list *l, void *item );
void *	      list_pop_tail( struct list *l );
void *	      list_peek_tail( struct list *l );

void *        list_find( struct list *l, list_op_t comparator, const void *arg );
void *        list_remove( struct list *l, list_op_t comparator, const void *arg );
int           list_iterate( struct list *l, list_op_t operator, const void *arg );
int           list_iterate_reverse( struct list *l, list_op_t operator, const void *arg );

#endif
