/*
Kangaroo is Copyright (C) 2001 Douglas Thain.
Permission is granted to use the source code for research and study purposes.
Other uses must be cleared with the copyright holder.
*/


#ifndef MESSAGE_LIST_H
#define MESSAGE_LIST_H

#include "kangaroo_message.h"

struct message_list * message_list_create();

int message_list_load( struct message_list *l );
int message_list_add( struct message_list *l, struct kangaroo_message *m );
int message_list_read( struct message_list *l, struct kangaroo_message *m );
void message_list_push( struct message_list *l, struct kangaroo_message *m );

int message_list_contains_host( struct message_list *l, const char *addr );

struct kangaroo_message * message_list_consume( struct message_list *l );
int message_list_consume_peek( struct message_list *l );
int message_list_consume_commit( struct message_list *l );
void message_list_consume_abort( struct message_list *l );

typedef int (*message_list_op_t) ( struct kangaroo_message *m, void *arg );
int message_list_iterate( struct message_list *l, message_list_op_t iterator, void *arg );
int message_list_iterate_reverse( struct message_list *l, message_list_op_t iterator, void *arg );

#endif
