/*
Kangaroo is Copyright (C) 2001 Douglas Thain.
Permission is granted to use the source code for research and study purposes.
Other uses must be cleared with the copyright holder.
*/


#include "reaper.h"
#include "spool_dir.h"
#include "list.h"
#include "debug.h"

#include <pthread.h>
#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/stat.h>

static pthread_mutex_t mutex = PTHREAD_MUTEX_INITIALIZER;
static pthread_cond_t cond = PTHREAD_COND_INITIALIZER;
static struct list *list;

static void * reaper_thread( void *arg )
{
	char *name;
	//int fret;
	//struct stat buf;

	while(1) {

		pthread_mutex_lock(&mutex);

		while(1) {
			name = list_pop_tail(list);
			if(!name) {
				pthread_cond_broadcast(&cond);
				pthread_cond_wait(&cond,&mutex);
			} else {
				break;
			}
		}

		pthread_mutex_unlock(&mutex);

		//fret = stat (name, &buf);
    	unlink(name);
		/*
    	if (fret != -1) {
      		spool_dir_space_remaining += buf.st_size;
      		debug ("spool dir space remaining:%d\n", spool_dir_space_remaining);
    	}
		else {
			debug ("stat returned -1, because %s\n", strerror(errno));
		}
		*/
    	debug("reaper: deleted %s\n",name);
    	free(name);
   }/*end while*/

	return 0;
}

int reaper_flush()
{
	pthread_mutex_lock(&mutex);
	while(list && list_size(list)) {
		pthread_cond_wait(&cond,&mutex);
	}
	pthread_mutex_unlock(&mutex);
	return 1;
}

int reaper_queue( const char *name )
{
	char *copy;
	pthread_t tid;

	pthread_mutex_lock(&mutex);

	if(!list) {
		list = list_create();
		if(!list) goto failure;
		pthread_create(&tid,0,reaper_thread,0);
	}

	copy = strdup(name);
	if(!copy) goto failure;

	if(!list_push_head(list,copy)) goto failure;

	pthread_cond_broadcast(&cond);
	pthread_mutex_unlock(&mutex);

	return 1;

	failure:
	pthread_mutex_unlock(&mutex);
	return 0;
}
