/*
Kangaroo is Copyright (C) 2001 Douglas Thain.
Permission is granted to use the source code for research and study purposes.
Other uses must be cleared with the copyright holder.
*/


#ifndef STRINGTOOLS_H
#define STRINGTOOLS_H

#if defined(__cplusplus)
extern "C" {
#endif

/*
Compares 'pattern' against 'text'.
'pattern' may contain up to one * wildcard.
Returns true if they match, false otherwise.
*/

int pattern_match( const char *pattern, const char *text );

/*
Returns a pointer to a static buffer containing the first
'length' bytes of 'str'.
*/

char * strfront( const char *str, int length );

/*
Returns a pointer to the last 'length' bytes of 'str'.
Does *not* use a static buffer, so it is thread-safe.
*/

const char * strback( const char *str, int length );

/*
Remove any trailing newlines.
*/

void chomp( char *buffer );

/*
Fills a string buffer so that it contains 'value'
in metric form.  If power==-1, then choose the best prefix
automatically.  Otherwise, use the prefix corresponding
to 2^(10*power).
*/

void metric_units( int value, int power, char *buffer );

#if defined(__cplusplus)
}
#endif

#endif
